Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## jcontrol.io
Interface BasicInputStream

All Known Subinterfaces:
  ConsoleInputStream

All Known Implementing Classes:
  Console, FileInputStream, I2C, Resource, RS232, SocketInputStream, UART

Deprecated.

    public interface BasicInputStream

Provides a set of low-level communication methods for reading.

Method Summary
`int` | `available()` Deprecated. Returns the number of bytes that can be read (or skipped over) from this input stream without blocking by the next caller of a method for this input stream.
`void` | `close()` Deprecated. Closes this input stream and releases any system resources associated with the stream.
`void` | `mark(int readlimit)` Deprecated. Marks the current position in this input stream.
`boolean` | `markSupported()` Deprecated. Tests if this input stream supports the `mark` and `reset` methods.
`int` | `read()` Deprecated. Reads the next byte of data from the input stream.
`int` | `read(byte[] b)` Deprecated. Reads some number of bytes from the input stream and stores them into the buffer array `b`.
`int` | `read(byte[] b, int off, int len)` Deprecated. Reads up to `len` bytes of data from the input stream into an array of bytes.
`void` | `reset()` Deprecated. Repositions this stream to the position at the time the `mark` method was last called on this input stream.
`int` | `skip(int n)` Deprecated. Skips over and discards `n` bytes of data from this input stream.

Method Detail

### read

    int read()
             throws IOException

  Deprecated.
  Reads the next byte of data from the input stream. The value byte is returned as an `int` in the range `0` to `255`. If no byte is available because the end of the stream has been reached, the value `-1` is returned. This method blocks until input data is available, the end of the stream is detected, or an exception is thrown.

  A subclass must provide an implementation of this method.

  Returns:
    the next byte of data, or `-1` if the end of the stream is reached.
  Throws:
    `IOException` - if an I/O error occurs.

### read

    int read(byte[] b)
             throws IOException

  Deprecated.
  Reads some number of bytes from the input stream and stores them into the buffer array `b`. The number of bytes actually read is returned as an integer. This method blocks until input data is available, end of file is detected, or an exception is thrown.

  If `b` is `null`, a `NullPointerException` is thrown. If the length of `b` is zero, then no bytes are read and `0` is returned; otherwise, there is an attempt to read at least one byte. If no byte is available because the stream is at end of file, the value `-1` is returned; otherwise, at least one byte is read and stored into `b`.

  The first byte read is stored into element `b[0]`, the next one into `b[1]`, and so on. The number of bytes read is, at most, equal to the length of `b`. Let k be the number of bytes actually read; these bytes will be stored in elements `b[0]` through `b[`k`-1]`, leaving elements `b[`k`]` through `b[b.length-1]` unaffected.

  If the first byte cannot be read for any reason other than end of file, then an `IOException` is thrown. In particular, an `IOException` is thrown if the input stream has been closed.

  The `read(b)` method for class `InputStream` has the same effect as:

       read(b, 0, b.length)

  Parameters:
    `b` - the buffer into which the data is read.
  Returns:
    the total number of bytes read into the buffer, or `-1` is there is no more data because the end of the stream has been reached.
  Throws:
    `IOException` - if an I/O error occurs.
    `NullPointerException` - if `b` is `null`.
  See Also:
    `InputStream.read(byte[], int, int)`

### read

    int read(byte[] b,
             int off,
             int len)
             throws IOException

  Deprecated.
  Reads up to `len` bytes of data from the input stream into an array of bytes. An attempt is made to read as many as `len` bytes, but a smaller number may be read, possibly zero. The number of bytes actually read is returned as an integer.

  This method blocks until input data is available, end of file is detected, or an exception is thrown.

  If `b` is `null`, a `NullPointerException` is thrown.

  If `off` is negative, or `len` is negative, or `off+len` is greater than the length of the array `b`, then an `IndexOutOfBoundsException` is thrown.

  If `len` is zero, then no bytes are read and `0` is returned; otherwise, there is an attempt to read at least one byte. If no byte is available because the stream is at end of file, the value `-1` is returned; otherwise, at least one byte is read and stored into `b`.

  The first byte read is stored into element `b[off]`, the next one into `b[off+1]`, and so on. The number of bytes read is, at most, equal to `len`. Let k be the number of bytes actually read; these bytes will be stored in elements `b[off]` through `b[off+`k`-1]`, leaving elements `b[off+`k`]` through `b[off+len-1]` unaffected.

  In every case, elements `b[0]` through `b[off]` and elements `b[off+len]` through `b[b.length-1]` are unaffected.

  If the first byte cannot be read for any reason other than end of file, then an `IOException` is thrown. In particular, an `IOException` is thrown if the input stream has been closed.

  Parameters:
    `b` - the buffer into which the data is read.
    `off` - the start offset in array `b` at which the data is written.
    `len` - the maximum number of bytes to read.
  Returns:
    the total number of bytes read into the buffer, or `-1` if there is no more data because the end of the stream has been reached.
  Throws:
    `IOException` - if an I/O error occurs.
    `NullPointerException` - if `b` is `null`.
  See Also:
    `InputStream.read()`

### skip

    int skip(int n)
             throws IOException

  Deprecated.
  Skips over and discards `n` bytes of data from this input stream. The `skip` method may, for a variety of reasons, end up skipping over some smaller number of bytes, possibly `0`. This may result from any of a number of conditions; reaching end of file before `n` bytes have been skipped is only one possibility. The actual number of bytes skipped is returned. If `n` is negative, no bytes are skipped.

  The `skip` method of `InputStream` creates a byte array and then repeatedly reads into it until `n` bytes have been read or the end of the stream has been reached. Subclasses are encouraged to provide a more efficient implementation of this method.

  Parameters:
    `n` - the number of bytes to be skipped.
  Returns:
    the actual number of bytes skipped.
  Throws:
    `IOException` - if an I/O error occurs.

### available

    int available()
                  throws IOException

  Deprecated.
  Returns the number of bytes that can be read (or skipped over) from this input stream without blocking by the next caller of a method for this input stream. The next caller might be the same thread or or another thread.

  Returns:
    the number of bytes that can be read from this input stream without blocking.
  Throws:
    `IOException` - if an I/O error occurs.

### close

    void close()
               throws IOException

  Deprecated.
  Closes this input stream and releases any system resources associated with the stream.

  The `close` method of `InputStream` does nothing.

  Throws:
    `IOException` - if an I/O error occurs.

### mark

    void mark(int readlimit)

  Deprecated.
  Marks the current position in this input stream. A subsequent call to the `reset`method repositions this stream at the last marked position so that subsequent reads re-read the same bytes.

  ``
  Parameters:
    `readlimit` - the maximum limit of bytes that can be read before the mark position becomes invalid.

### reset

    void reset()
               throws IOException

  Deprecated.
  Repositions this stream to the position at the time the `mark` method was last called on this input stream.

  Throws:
    `IOException` - if this stream has not been makred or if the mark has been invalidated.

### markSupported

    boolean markSupported()

  Deprecated.
  Tests if this input stream supports the `mark` and `reset` methods.

  Returns:
    `true` if this stream instance supports the mark and reset methods; `false` otherwise.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD